class MyScene3D : public Scene3D
{
  public:
    D3DXVECTOR3 cameraPos;
    D3DXVECTOR3 cameraLookAt;

    Object3D*   ball;

  public:
    MyScene3D(Control3D* _lpControl3D);
    ~MyScene3D();

    void init();
    void render();
    void move();
};

MyScene3D::MyScene3D(Control3D* _lpControl3D)
              : Scene3D(_lpControl3D)
{
  ball = new Object3D(lpControl3D, "b_kugel.x");
  init();
}

MyScene3D::~MyScene3D()
{
  delete ball;
}

void MyScene3D::init()
{
  ball->pos    = D3DXVECTOR3(-30.0, 0.0, 0.0);
  ball->speed  = D3DXVECTOR3(10.0, 25.0, 0.0);
  ball->accel  = D3DXVECTOR3(0.0, -10.0, 0.0);

  cameraPos    = D3DXVECTOR3(0.0, 50.0, -50.0);
  cameraLookAt = D3DXVECTOR3(0.0, 0.0, 0.0);
}

void MyScene3D::render()
{
  D3DXMATRIX view;

  lpDevice->Clear(0, NULL, D3DCLEAR_TARGET|D3DCLEAR_ZBUFFER,
                  D3DCOLOR_XRGB(0, 5, 10), 1.0f, 0);

  //Matrix fr Kameraposition und -blickrichtung  setzen
  D3DXMatrixLookAtLH(&view, &cameraPos, &cameraLookAt,
                     &D3DXVECTOR3(0.0f, 1.0f, 0.0f));
  lpDevice->SetTransform(D3DTS_VIEW, &view);

  //Beginn der 3D-Szene
  lpDevice->BeginScene();

  //Ball zeichnen
  ball->draw();

  //Ende der 3D-Szene
  lpDevice->EndScene();
  lpDevice->Present(NULL, NULL, NULL, NULL);
}

void MyScene3D::move()
{
  ball->move(0.1);
}
