//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#define D3D_DEBUG_INFO

#include "UnitDirect3D_1.h"
#include "UnitHomepage1.h"

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"

TFormDirect3DSetup *FormDirect3DSetup;

//---------------------------------------------------------------------------
__fastcall TFormDirect3DSetup::TFormDirect3DSetup(TComponent* Owner)
        : TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TFormDirect3DSetup::FormCreate(TObject *Sender)
{
  lpDirect3DSetup = new Direct3DSetup();
  lpSetupControls =
              new SetupControls(lpDirect3DSetup,
                                FormDirect3DSetup,
                                ComboBoxAdapters,
                                ComboBoxModes,
                                PanelType,
                                PanelWindowed,
                                ComboBoxBackBuffer,
                                ComboBoxZStencil,
                                ComboBoxSampleType,
                                ComboBoxSampleQuality);

}
//---------------------------------------------------------------------------

void __fastcall TFormDirect3DSetup::FormDestroy(TObject *Sender)
{
  delete lpSetupControls;
  delete lpDirect3DSetup;
}
//---------------------------------------------------------------------------

void __fastcall TFormDirect3DSetup::ComboBoxAdaptersChange(TObject *Sender)
{
  lpSetupControls->updateAdapter();
  lpSetupControls->refreshType();
  lpSetupControls->refreshWindowed();
  lpSetupControls->refreshModes();
  lpSetupControls->refreshBackBufferFormats();
  lpSetupControls->refreshZStencilBufferFormats();
  lpSetupControls->refreshMultiSampleTypes();
  lpSetupControls->refreshMultiSampleQuality();
}

//---------------------------------------------------------------------------
void __fastcall TFormDirect3DSetup::RadioButtonHALClick(TObject *Sender)
{
  lpSetupControls->updateType();
  lpSetupControls->refreshWindowed();
  lpSetupControls->refreshModes();
  lpSetupControls->refreshBackBufferFormats();
  lpSetupControls->refreshZStencilBufferFormats();
  lpSetupControls->refreshMultiSampleTypes();
  lpSetupControls->refreshMultiSampleQuality();
}
//---------------------------------------------------------------------------

void __fastcall TFormDirect3DSetup::RadioButtonFullScreenClick(TObject *Sender)
{
  lpSetupControls->updateWindowed();
  lpSetupControls->refreshModes();
  lpSetupControls->refreshBackBufferFormats();
  lpSetupControls->refreshZStencilBufferFormats();
  lpSetupControls->refreshMultiSampleTypes();
  lpSetupControls->refreshMultiSampleQuality();
}
//---------------------------------------------------------------------------

void __fastcall TFormDirect3DSetup::ComboBoxModesChange(TObject *Sender)
{
  lpSetupControls->updateMode();
  lpSetupControls->refreshBackBufferFormats();
  lpSetupControls->refreshZStencilBufferFormats();
  lpSetupControls->refreshMultiSampleTypes();
  lpSetupControls->refreshMultiSampleQuality();
}
//---------------------------------------------------------------------------


void __fastcall TFormDirect3DSetup::ComboBoxBackBufferChange(TObject *Sender)
{
  lpSetupControls->updateBackBufferFormat();
  lpSetupControls->refreshZStencilBufferFormats();
  lpSetupControls->refreshMultiSampleTypes();
  lpSetupControls->refreshMultiSampleQuality();
}
//---------------------------------------------------------------------------

void __fastcall TFormDirect3DSetup::ComboBoxZStencilChange(TObject *Sender)
{
  lpSetupControls->updateZStencilBufferFormat();
  lpSetupControls->refreshMultiSampleTypes();
  lpSetupControls->refreshMultiSampleQuality();
}
//---------------------------------------------------------------------------

void __fastcall TFormDirect3DSetup::ComboBoxSampleTypeChange(TObject *Sender)
{
  lpSetupControls->updateMultiSampleType();
  lpSetupControls->refreshMultiSampleQuality();
}
//---------------------------------------------------------------------------


void __fastcall TFormDirect3DSetup::ComboBoxSampleQualityChange(TObject *Sender)
{
  lpSetupControls->updateMultiSampleQuality();
}
//---------------------------------------------------------------------------


void __fastcall TFormDirect3DSetup::ButtonLaunchClick(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------

